#ifndef __Mt_Edgemask_H__
#define __Mt_Edgemask_H__

#include "../../../common/base/filter.h"

namespace MaskTools { namespace Filters { namespace Mask { namespace Edge {

typedef void(Processor)(Byte *pDst, int nDstPitch, const Byte *pSrc, int nSrcPitch, const Word matrix[10], int nLowThreshold, int nHighThreshold, int nWidth, int nHeight);

class Filter : public MaskTools::Filter
{
   int nLowThresholdY;
   int nHighThresholdY;
   int nLowThresholdUV;
   int nHighThresholdUV;
   Word matrix[10];

protected:
   virtual void ProcessY(PlaneProcessor *processor, Picture::Plane &dst, Picture::CPlane &src1,
                         Picture::CPlane &src2, Picture::CPlane &src3);

   virtual void ProcessU(PlaneProcessor *processor, Picture::Plane &dst, Picture::CPlane &src1,
                         Picture::CPlane &src2, Picture::CPlane &src3);

   virtual void ProcessV(PlaneProcessor *processor, Picture::Plane &dst, Picture::CPlane &src1,
                         Picture::CPlane &src2, Picture::CPlane &src3);

public:
   Filter(const Parameters::Parameters &parameters);

   static String getName();
   static Parameters::Signature getSignature();
   static Clip::Inputs inputClips;
};

extern Processor *convolution_c;
extern Processor *convolution8_mmx;

extern Processor *sobel_c;
extern Processor *sobel8_mmx;

extern Processor *roberts_c;
extern Processor *roberts8_mmx;

extern Processor *laplace_c;
extern Processor *laplace8_mmx;

} } } }

#endif