#ifndef __Mt_Hysteresis_H__
#define __Mt_Hysteresis_H__

#include "../../../common/base/filter.h"

namespace MaskTools { namespace Filters { namespace Mask { namespace Hysteresis {

typedef void(Processor)(Byte *pDst, int nDstPitch, const Byte *pSrc1, int nSrc1Pitch,
                        const Byte *pSrc2, int nSrc2Pitch, Byte *pTemp, int nWidth, int nHeight);

class Filter : public MaskTools::Filter
{

   Byte *pbStack;

   void initializeStack();

protected:
   virtual void ProcessY(PlaneProcessor *processor, Picture::Plane &dst, Picture::CPlane &src1,
                         Picture::CPlane &src2, Picture::CPlane &src3);

   virtual void ProcessU(PlaneProcessor *processor, Picture::Plane &dst, Picture::CPlane &src1,
                         Picture::CPlane &src2, Picture::CPlane &src3);

   virtual void ProcessV(PlaneProcessor *processor, Picture::Plane &dst, Picture::CPlane &src1,
                         Picture::CPlane &src2, Picture::CPlane &src3);

public:
   Filter(const Parameters::Parameters &parameters);
   ~Filter();

   static String getName();
   static Parameters::Signature getSignature();
   static Clip::Inputs inputClips;
};

Processor hysteresis_c;

} } } }

#endif